#include <bits/stdc++.h>
#define MAXN 200010

using namespace std;

int a[MAXN], p[MAXN], cr[MAXN];

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); 
	
	int n, q; cin >> n;
	
	for(int i = 0; i < n; i++) cin >> a[i];
	
	for(int i = 0; i < n - 1; i++)
	{
		if(a[i] > a[i + 1]) p[i] += 1;
		
		p[i + 1] = p[i];
	}
	
	for(int i = 0; i < n - 3; i++)
	{
		if(a[i] > a[i + 2] && a[i] > a[i + 3] && a[i + 1] > a[i + 2] && a[i + 1] > a[i + 3]) cr[i] += 1;
		
		cr[i + 1] = cr[i];
	}
	
	cin >> q;
	
	while(q--)
	{
		int l, r; cin >> l >> r;
		
		l--; r--;
		
		if(cr[r - 3] - cr[l - 1] > 0 || p[r - 1] - p[l - 1] > 1) cout << "NE\n";
		else cout << "DA\n";
	}
	
	
	return 0;
}